# coding: utf-8

"""
    Xray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from openapi_client.models.data_field import DataField
from openapi_client.models.option_field import OptionField
from openapi_client.models.wiki_field import WikiField
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

STEPFIELDSVALUE_ONE_OF_SCHEMAS = ["DataField", "OptionField", "WikiField"]

class StepFieldsValue(BaseModel):
    """
    StepFieldsValue
    """
    # data type: DataField
    oneof_schema_1_validator: Optional[DataField] = None
    # data type: OptionField
    oneof_schema_2_validator: Optional[OptionField] = None
    # data type: WikiField
    oneof_schema_3_validator: Optional[WikiField] = None
    actual_instance: Optional[Union[DataField, OptionField, WikiField]] = None
    one_of_schemas: Set[str] = { "DataField", "OptionField", "WikiField" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = StepFieldsValue.model_construct()
        error_messages = []
        match = 0
        # validate data type: DataField
        if not isinstance(v, DataField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DataField`")
        else:
            match += 1
        # validate data type: OptionField
        if not isinstance(v, OptionField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `OptionField`")
        else:
            match += 1
        # validate data type: WikiField
        if not isinstance(v, WikiField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `WikiField`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in StepFieldsValue with oneOf schemas: DataField, OptionField, WikiField. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in StepFieldsValue with oneOf schemas: DataField, OptionField, WikiField. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into DataField
        try:
            instance.actual_instance = DataField.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into OptionField
        try:
            instance.actual_instance = OptionField.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into WikiField
        try:
            instance.actual_instance = WikiField.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into StepFieldsValue with oneOf schemas: DataField, OptionField, WikiField. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into StepFieldsValue with oneOf schemas: DataField, OptionField, WikiField. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], DataField, OptionField, WikiField]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


